
#include "BatteryCheck.h"


unsigned char Get_VDD(void)
{
	unsigned int zz;

	PMMCTL0=0XA500;
    PMMCTL2|=INTREFEN;

	ADCCTL0|=ADCSHT_3+ADCON;
	ADCCTL1= ADCSHS_0+ADCSSEL_2+ADCDIV_0+ADCCONSEQ_0+ADCSHP;
	ADCMCTL0=ADCSREF_0+ADCINCH_13;
	ADCCTL0|=ADCENC+ADCSC;
    while(!(ADCIFG && ADCIFG0));


	zz = ADCMEM0;
	zz = zz >> 2;

	ADCCTL0 &= ~ADCENC;
	ADCCTL0 =0;
	ADCMCTL0=0;
	ADCCTL1=0;
	PMMCTL0=0XA500;
	PMMCTL2&=~INTREFEN;

    return (unsigned char)zz;

}

void check_battery()
{   unsigned char temp;
    temp=Get_VDD();
    if(temp>=166)                          //<=2.3V    none
    SysData.SysStatus.batterylevel=none;
    else if(temp>=153)                     //2.3V~2.5v low
    SysData.SysStatus.batterylevel=stage1;
    else if(temp>=147)
    SysData.SysStatus.batterylevel=stage2; //2.5V~2.6V middle
    else
    SysData.SysStatus.batterylevel=stage3; //>=2.6V    high
}

