/*
 * KeyProcess.c
 *
 *  Created on: Sep 26, 2013
 *      Author: a0282243
 */

#include "KeyProcess.h"
void Key_Plus_process();
void key_On_off_process();
void Key_Mode_process();
void Key_Fan_Speed_process();
void Key_Minus_process();
void Key_Sleep_process();
void Key_Dry_process();
void key_Health_process();
void Key_Light_process();
void Key_Mute_process();
void Key_Lock_process();
void Key_LeftRt_Wind_process();
void Key_UpDwn_wind_process();
void key_Maxpower_process();
void key_Savepower_process();
void Key_Temp_Position_process();
void Key_Timer_process();

unsigned char on2off_flag=0;

void KeyProcess(unsigned char KeyValue) {

   if((SysData.SysStatus.KeyShift==1) && (KeyValue==Key_Dry))
     {
	   if(SysData.SysStatus.SysLock)
	   return;
	   if(SysData.SysStatus.SysON == OFF)
	   return;
	   SysData.CurrentMode=&(SysData.SysMode[1]);
     }

   if((SysData.SysStatus.KeyShift==1) && (KeyValue==Key_Health))
	 {
	   if(SysData.SysStatus.SysLock)
	   return;

	   if(SysData.SysStatus.SysON == OFF)
	   return;
	   SysData.CurrentMode=&(SysData.SysMode[4]);
	 }

   switch(KeyValue) {
   case Key_On_off :
       key_On_off_process();
       break;
   case Key_Mode :
       Key_Mode_process();
       break;
   case Key_Fan_Speed:
	   Key_Fan_Speed_process();
	   break;
   case Key_Plus:
       Key_Plus_process();
       break;
   case Key_Minus:
       Key_Minus_process();
       break;
   case Key_Sleep :
       Key_Sleep_process();
       break;
   case Key_TimerDelay :
	   Key_Timer_process();
       break;
   case Key_Dry:
       Key_Dry_process();
       break;
   case Key_Health:
	   key_Health_process();
	   break;
   case Key_Light :
       Key_Light_process();
       break;
   case Key_Mute :
       Key_Mute_process();
       break;
   case Key_Max_Power :
       key_Maxpower_process();
       break;
   case Key_SavePower :
	   key_Savepower_process();
	   break;
   case Key_UpDwn_wind :
       Key_UpDwn_wind_process();
       break;
   case Key_LeftRt_Wind :
       Key_LeftRt_Wind_process();
       break;
   case Key_Temp_Position:
	   Key_Temp_Position_process();
	   break;
   case Key_Lock:
       Key_Lock_process();
       break;

   default : break;
   }
}


void key_On_off_process() {
   if(SysData.SysStatus.SysLock)
    return;

   if(SysData.SysStatus.SysON == ON)
     {SysData.SysStatus.SysON = OFF;
      on2off_flag=1;}
   else
     SysData.SysStatus.SysON = ON;

}



void Key_Mode_process() {
   if(SysData.SysStatus.SysLock)
    return;

   if(SysData.SysStatus.SysON == OFF)
    return;

   if(SysData.CurrentMode == &SysData.SysMode[MODE_NUM-1])
       SysData.CurrentMode = &SysData.SysMode[0];
   else
       SysData.CurrentMode++;

}

void Key_Fan_Speed_process(){
   if(SysData.SysStatus.SysLock)
	  return;

   if(SysData.SysStatus.SysON == OFF)
	    return;
   (*SysData.CurrentMode).FanSpeed =  (*SysData.CurrentMode).FanSpeed->next ;


}

void Key_Plus_process() {
   if(SysData.SysStatus.SysLock)
    return;

   if(((SysData.SysStatus.TimerMode2->element==Timer_shutdown)&&(SysData.SysStatus.SysON ==ON))||
		   ((SysData.SysStatus.TimerMode1->element==Timer_startup)&&(SysData.SysStatus.SysON ==OFF)))
   {
    SysData.SysStatus.TimerMinuterValue= SysData.SysStatus.TimerMinuterValue->next;
    if(SysData.SysStatus.TimerMinuterValue->element==0)
    {
      if(SysData.SysStatus.TimerValue->element==23)                           //需要这样才可以实现链表双向循环，自己新建的链表在边界变化时会出现错误，可能是由于内存大小受限，溢出了。
    	SysData.SysStatus.TimerValue=TimerValueCircleLink;
      else
        SysData.SysStatus.TimerValue=SysData.SysStatus.TimerValue->next;
    }
   }
   else if(SysData.SysStatus.SysON ==OFF)
   return;
   else
   (*SysData.CurrentMode).Temperature =  (*SysData.CurrentMode).Temperature->next ;


}


void Key_Minus_process() {
   if(SysData.SysStatus.SysLock)
    return;

   if(((SysData.SysStatus.TimerMode2->element==Timer_shutdown)&&(SysData.SysStatus.SysON ==ON))||
		   ((SysData.SysStatus.TimerMode1->element==Timer_startup)&&(SysData.SysStatus.SysON ==OFF)))
   {
    SysData.SysStatus.TimerMinuterValue= SysData.SysStatus.TimerMinuterValue->previous;
	if(SysData.SysStatus.TimerMinuterValue->element==5)
	{
	   if(SysData.SysStatus.TimerValue->element==00)            //需要这样才可以实现链表双向循环，自己新建的链表在边界变化时会出现错误，可能是由于内存大小受限，溢出了。
	   SysData.SysStatus.TimerValue=&TimerValueCircleLink[23];
	   else
       SysData.SysStatus.TimerValue=SysData.SysStatus.TimerValue->previous;
	}
   }
   else if(SysData.SysStatus.SysON ==OFF)
   return;
   else
   (*SysData.CurrentMode).Temperature =  (*SysData.CurrentMode).Temperature->previous;

}



void Key_Sleep_process() {
   if(SysData.SysStatus.SysLock)
    return;

   if(SysData.SysStatus.SysON == OFF)
    return;

   (*SysData.CurrentMode).SleepMode = (*SysData.CurrentMode).SleepMode->next;
    if(SysData.CurrentMode->SleepMode->element!=sleepmode_start)
    	SysData.SysStatus.Mute=1;
}

void Key_Timer_process(){

	if(SysData.SysStatus.SysLock)
	 return;

    if(SysData.SysStatus.SysON == OFF)
    SysData.SysStatus.TimerMode1=SysData.SysStatus.TimerMode1->next;


    if(SysData.SysStatus.SysON == ON)
    SysData.SysStatus.TimerMode2=SysData.SysStatus.TimerMode2->next;
}

void Key_Dry_process() {
   if(SysData.SysStatus.SysLock)
    return;

   if(SysData.SysStatus.SysON == OFF)
    return;

   if(SysData.SysStatus.KeyShift == ON)
	return;

   SysData.CurrentMode->AuxHeat=SysData.CurrentMode->AuxHeat->next;

}

void key_Health_process(){
	if(SysData.SysStatus.SysLock)
    return;

	if(SysData.SysStatus.SysON == OFF)
    return;

	if(SysData.SysStatus.KeyShift == ON)
	return;

	if((*SysData.CurrentMode).Healthy == ON )
	    (*SysData.CurrentMode).Healthy =OFF;
	else
	    (*SysData.CurrentMode).Healthy = ON;

}
void Key_Light_process(){
       if(SysData.SysStatus.SysLock)
        return;

       if(SysData.SysStatus.SysON == OFF)
        return;

       if(SysData.SysStatus.light == ON )
           SysData.SysStatus.light =OFF;
       else
           SysData.SysStatus.light = ON;

}


void Key_Mute_process(){
       if(SysData.SysStatus.SysLock)
        return;

       if(SysData.SysStatus.SysON == OFF)
        return;

       if(SysData.SysStatus.Mute == ON )
           SysData.SysStatus.Mute =OFF;
       else
           SysData.SysStatus.Mute = ON;

}


void key_Maxpower_process() {
     if(SysData.SysStatus.SysLock)
      return;

     if(SysData.SysStatus.SysON == OFF)
      return;

     if(  (*SysData.CurrentMode).MaxPower == ON)
         (*SysData.CurrentMode).MaxPower = OFF;
     else
         (*SysData.CurrentMode).MaxPower = ON;

}

void key_Savepower_process(){
  if(SysData.SysStatus.SysLock)
   return;

  if(SysData.SysStatus.SysON == OFF)
   return;

  if(  (*SysData.CurrentMode).SavePower == ON)
      (*SysData.CurrentMode).SavePower = OFF;
  else
      (*SysData.CurrentMode).SavePower = ON;
}


void Key_UpDwn_wind_process(){

       if(SysData.SysStatus.SysLock)
        return;

       if(SysData.SysStatus.SysON == OFF)
        return;
       (*SysData.CurrentMode).UpDwnFanMode =  (*SysData.CurrentMode).UpDwnFanMode->next ;

}

void Key_LeftRt_Wind_process(){

       if(SysData.SysStatus.SysLock)
        return;
       if(SysData.SysStatus.SysON == OFF)
        return;
       (*SysData.CurrentMode).LeftRightFanMode = (*SysData.CurrentMode).LeftRightFanMode->next;

}

void Key_Temp_Position_process(){

       if(SysData.SysStatus.SysLock)
        return;
       if(SysData.SysStatus.SysON == OFF)
        return;
       SysData.SysStatus.TempPositon=SysData.SysStatus.TempPositon->next;

}

void Key_Lock_process() {
       if(SysData.SysStatus.SysLock == ON)
           SysData.SysStatus.SysLock =OFF;
       else
           SysData.SysStatus.SysLock = ON;
}




