/*
 * LpmProcess.c
 *
 *  Created on: Oct 22, 2013
 *      Author: a0222702
 */
#include "LpmProcess.h"

void Sleep(void)
{
    TA1CCR0 = 0;
    TA1CTL = 0;
    TA1CCTL0= 0;
    Backup_Ram();


	CSCTL1 &=~ DCORSEL_3;
	CSCTL1 &=~ DCORSEL_2;
	CSCTL1 &=~ DCORSEL_1;                     //the clock frequency must be reduced low enough before enter LPM MODE

	PMMCTL0_H = PMMPW_H;                      // Open PMM Registers for write
	PMMCTL0_L |= PMMREGOFF;                   // and set PMMREGOFF
//	__bis_SR_register(LPM3_bits | GIE);       // enter LPM3.5
        __bis_SR_register(LPM3_bits );       // enter LPM3.5
}


void Backup_Ram(void)            //backup for ram
{
   unsigned int *ss ;
   unsigned int *dd ;
   unsigned int ii = 0;
   ss = (unsigned int *) 0x2000; // SRAM
   dd = (unsigned int *) 0x1800; // FRAM

   for (ii = 0; ii < 200; ii++)
   {
       SYSCFG0 &= ~DFWP;
       *dd=*ss;
       ss++;
       dd++;
       SYSCFG0 |= DFWP;
   }
}


void Release_Ram(void)           //release the backup ram
{
   unsigned int *ss ;
   unsigned int *dd ;
   unsigned int ii = 0;
   ss = (unsigned int *) 0x1800; // SRAM
   dd = (unsigned int *) 0x2000; // FRAM

   for (ii = 0; ii < 200; ii++)
   {
       SYSCFG0 &= ~DFWP;
       *dd=*ss;
       ss++;
       dd++;
       SYSCFG0 |= DFWP;
   }

}


void delay3s(void)
{
    CSCTL1 &=~ DCORSEL_3;
    CSCTL1 &=~ DCORSEL_2;
    CSCTL1 &=~ DCORSEL_1;
    __bis_SR_register(LPM3_bits+GIE);

}






