/*
 * TimerMonitor.c
 *
 *  Created on: Oct 28, 2013
 *      Author: a0222702
 */
#include "TimerMonitor.h"

unsigned char timer_finish_flag=0;

void timer_monitor()
{
	unsigned char timer_set;
	unsigned char timer_3second_counter;

	timer_set=(6*SysData.SysStatus.TimerValue->element+SysData.SysStatus.TimerMinuterValue->element);
	timer_3second_counter=LCDMEM[18];   //release

	if(timer_set)
	{
		if((SysData.SysStatus.TimerMinuterValue->element==0)&&(timer_3second_counter==200))   //200*3s=10min
		  {
		    SysData.SysStatus.TimerValue=SysData.SysStatus.TimerValue->previous;
			SysData.SysStatus.TimerMinuterValue=SysData.SysStatus.TimerMinuterValue->previous;
		  }
		else if(timer_3second_counter==200)
		  {

			SysData.SysStatus.TimerMinuterValue=SysData.SysStatus.TimerMinuterValue->previous;
		    timer_3second_counter=0;
		  }
		else
			timer_3second_counter++;


		if((SysData.SysStatus.TimerValue->element==0)&&(SysData.SysStatus.TimerMinuterValue->element==0))
	      {
			timer_3second_counter=0;
			if( SysData.SysStatus.SysON==ON)
			  {
				SysData.SysStatus.SysON=OFF;
			    SysData.SysStatus.TimerMode1=TimerMode1CircleLink;
			  }
		    else
		      {
		    	SysData.SysStatus.SysON=ON;
			    SysData.SysStatus.TimerMode2=TimerMode2CircleLink;
		      }
			 timer_finish_flag=1;
		  }

		LCDMEM[18]= timer_3second_counter;  //backup
	}
}
